#include <pic.h>
#include "delay.h"

// Configuration Bits (a.k.a. Fuses)
// Estas lineas son opcionales, ya que se pueden fijar externamente
// en MPLAB IDE bajo la opcion de la barra de menu
// <Configure/Configuration Bits...>
// Definiciones:
//  RC/HS/XT/LP: Oscilador RC, High-speed XTAL, XTAL, Low-power XTAL  
//  WDT: Watchdog Timer  (EN/DIS: Enable, Disable)
//  PWRT: Power-up Timer (EN/DIS: Enable, Disable)
//  PROTECT: Code write protection
__CONFIG(XT&WDTDIS&PWRTDIS&PROTECT);
//__CONFIG(RC&WDTEN&PWRTEN&UNPROTECT);

//#define XTAL_FREQ 20MHZ

#define PORTBIT(adr, bit) ((unsigned)(&adr)*8+(bit))

// Variables Globales
static volatile bit led @ PORTBIT(PORTB,7);
static volatile bit boton = 0;

// Funcion Interrupcion
static void interrupt isr(void)
{
	if(INTF){ // -- Flag Interrupcion en pin INT --
//		INTE = 0;  	// Deshabilita interrupciones en pin INT
		boton = 1; 	// Boton presionado
		INTF = 0; 	// Limpia flag de interrupcion INTF
		}
}

// Rutina Parpadeo
void blink(void){ // Parpadea el una veces antes de cambiar
                  // de estado
        char i;
	for(i=0;i<5;i++){
	DelayMs(125);}
	led = !led;
	for(i=0;i<5;i++){
	DelayMs(255);}
	led = !led;
	for(i=0;i<5;i++){
	DelayMs(125);}
	led = !led;
	for(i=0;i<5;i++){
	DelayMs(255);}
	led = !led;
}

// Rutina Principal
void main(void){
	led = 1;
//	OPTION	= 0b00000111; // Fija PS0-PS2 Pre-escaladores del
						  // Watchdog Timer WDTR
	TRISB   = 0b00000001; // Fija el pin RB0 en como entrada
						  // (en alta impedancia).
	INTE = 1; // Habilitacion de interrupciones externas.
	GIE  = 1; // Habilitacion global de interrupciones.
	// ei(); // Habilita todos los tipos de interruptciones
    // di(); // Deshabilita todas las interrupciones

 	for(;;){ // -- Loop sin fin --
 		if(boton){ // Boton presionado
 			boton = 0;  	// Limpia flag del boton presionado
 			led = !led; 	// Cambia el estado del led
			DelayUs(10);	// Espera 10 microsegundos
			blink();
		//	INTE = 1;		// Habilita interrupciones en pin INT
			}
		}
}
