#include	<pic.h>

/*
 *	Interrupt demo for PIC; wait for button press on RB0/INT,
 *	turn on a relay on another port bit for a period of time.
 *	For simplicity here, literal constants are used, usually these
 *	should be calculated with compile-time arithmetic.
 */

#define	XTAL	4000000		// crystal frequency - 4MHz
#define RELAY RB4					// use this bit to drive relay

static unsigned int	relay_timer;	// timer value for relay driver

void
main(void)
{
	/* setup stuff */

	RELAY = 1;		// ensure relay is off before enabling output
	TRISB = 0x03;	// Port B bits 7 and 6 are output 

	OPTION	= 0b00000111;
	TRISB	= 0b00000011;

//	RBPU = 0;		// Use internal pullups
//	T0IE = 1;		// Enable interrupt on TMR0 overflow
//	INTEDG = 1;		// falling edge trigger the interrupt
	INTE = 1;		// enable the external interrupt
	GIE = 1;		// Global interrupt enable
	for(;;){
		CLRWDT();	// Idly kick the dog
// continue;
	}
}

static void interrupt
isr(void)			// Here be interrupt function - the name is unimportant.
{
	if(INTF) {				// did we see a button press?
		if (RELAY){
		RELAY = 0;			// turn the relay on
		}
		else
		{RELAY = 1;
		}
		INTF = 0;			// clear the interrupt
	}
}

